#include "descriptor/descriptor.h"

int main(void) {

  ITEM  pelle, corpo_dino;
  ITEM  scena, viso;
  ITEM  occhiodx, occhiosx, occhio;
  ITEM  corpo, corpo1;
  ITEM  mani,mani1,mani_dino;
  ITEM  piano1,piano,base_piano;
  ITEM  vetro, pareti,pareti1;
  ITEM  palla, palla_bask;
  ITEM  canestro, canestro1,col_canestro;
  ITEM  pannello1, col_pannello, pannello;
  ITEM  col_tiro, tiro, tiro1;

  set_background(0,0,0,TRUE);
  set_ambient_light(1,1,1,0.7);
  create_point_light(-7.42,25.3,0.45,1,1,1,1.8,20,"luce");
  create_point_light(1.819,23.992,-43.288,0.5,0.5,0.25,1,15,"luce_1");
  create_point_light(11.163,-13.14,-2.245,0.3,0.1,0.25,1,15,"luce_3");

  pelle = create_attribute("pelle");
  set_color(pelle,0.98,0.64,0.49,0.3,0.65);
  set_reflectivity(pelle,0.16,1);

  occhio = create_attribute("occhio");
  set_color(occhio,0.94,0.97,0.008,1,1);
  set_reflectivity(occhio,0.9,0.5);

  corpo_dino = create_attribute("corpo");
  set_color(corpo_dino,0.43,0.68,0.28,1,1);


  mani_dino = create_attribute("mani");
  set_color(mani_dino, 0.43,0.68,0.28,1,1);

  base_piano = create_attribute("piano");
  set_color(base_piano, 0,1,0.1,0.2,0.2);

  palla_bask = create_attribute("palla");
  set_color(palla_bask,1,0.39,0.15,1,1);

  col_canestro = create_attribute("barre");
  set_color(col_canestro,0.55,0.55,0.55,1,1);

  col_pannello = create_attribute("pannello");
  set_color(col_pannello, 1,1,1,1,1);

  col_tiro = create_attribute("tiro");
  set_color(col_tiro,0,0,0,1,1);



  /*** ATTRIBUTO vetro ***/
  vetro = create_attribute("vetro");
  set_color(vetro,0.68,0.86,1,0.5,0.5);
  set_reflectivity(vetro,0.24,2);
  set_transparency(vetro,0.87,0.68,1,1.2);


/***********************************/
/*          Viso e hands          */
/*********************************/

viso = read_nurbs("testa.db");

/*********************************/
/*         Occhi                 */
/********************************/

occhiodx = read_nurbs("occhiosx.db");
occhiosx = read_nurbs("occhiodx.db");
set_attribute(occhiodx, occhio);
set_attribute(occhiosx, occhio);

/*********************************/
/*         Corpo                 */
/********************************/

corpo1 = read_nurbs("corpo.dbe");
corpo = create_list(corpo1, "corpo");
corpo = insert_in_list(corpo,read_nurbs("coda.db"));
corpo = insert_in_list(corpo,read_nurbs("gambasx.db"));
corpo = insert_in_list(corpo,read_nurbs("gambadx.db"));
corpo = insert_in_list(corpo,viso);
set_attribute(corpo,corpo_dino);


/******************************/
/*        Mani  e braccia    */
/*****************************/

mani1 = read_nurbs("manodx.dbe");
mani  = create_list(mani1, "mani");
mani  = insert_in_list(mani,read_nurbs("manosx.dbe"));
mani  = insert_in_list(mani,read_nurbs("pollicedx.db"));
mani  = insert_in_list(mani,read_nurbs("pollicesx.db"));
mani  = insert_in_list(mani,read_nurbs("polsodx.db"));
mani  = insert_in_list(mani,read_nurbs("polsosx.db"));
mani  = insert_in_list(mani,read_nurbs("cilindro.db"));
mani  = insert_in_list(mani,read_nurbs("bracciosx.db"));
mani  = insert_in_list(mani,read_nurbs("bracciodx.db"));
set_attribute(mani,mani_dino);

/**********************************/
/*       Piano                   */
/*********************************/
piano1 = read_nurbs("stanza1.db");
piano  = create_list(piano1, "piano");
piano = insert_in_list(piano, read_nurbs("stanza1.db"));
set_attribute(piano,vetro);

/**********************************/
/*       Pareti                   */
/*********************************/
pareti1 = read_nurbs("stanza2.db");
pareti = create_list(pareti1, "pareti");
pareti = insert_in_list(pareti, read_nurbs("stanza3.db"));
pareti = insert_in_list(pareti, read_nurbs("stanza4.db"));
set_attribute(pareti,vetro);

/**********************************/
/*       Palla                    */
/*********************************/
palla = read_nurbs("palla.db");
set_attribute(palla,palla_bask);

/**********************************/
/*       Canestro                */
/*********************************/
canestro1 = read_nurbs("canestro2.db");
canestro = create_list(canestro1, "canestro");
canestro = insert_in_list(canestro, read_nurbs("barra1.db"));
canestro = insert_in_list(canestro, read_nurbs("barra2.db"));
canestro = insert_in_list(canestro, read_nurbs("barra3.db"));
canestro = insert_in_list(canestro, read_nurbs("barra4.db"));
canestro = insert_in_list(canestro, read_nurbs("barra5.db"));
canestro = insert_in_list(canestro, read_nurbs("barra6.db"));
canestro = insert_in_list(canestro, read_nurbs("barra7.db"));
canestro = insert_in_list(canestro, read_nurbs("barra8.db"));
canestro = insert_in_list(canestro, read_nurbs("canestro4.db"));
set_attribute(canestro,col_canestro);

/**********************************/
/*       Pannello                */
/*********************************/
pannello1 = read_nurbs("canestro.db");
pannello = create_list(pannello1, "pannello");
pannello = insert_in_list(pannello, read_nurbs("canestro3.db"));
set_attribute(pannello, col_pannello);


tiro1 = read_nurbs("tiro.dbe");
tiro = create_list(tiro1, "tiro");
tiro = insert_in_list(tiro, read_nurbs("tiro2.dbe"));
tiro = insert_in_list(tiro, read_nurbs("nuovocerchio.db"));
tiro = insert_in_list(tiro, read_nurbs("nuovocerchio2.db"));
tiro = insert_in_list(tiro, read_nurbs("nuovocerchio3.db"));
set_attribute(tiro, col_tiro);


/**********************************/
/*         Texture Mapping       */
/*********************************/

set_projection_texture(occhiodx,occhio, "textures/fundo10.hr", FALSE, FALSE,1,1);
set_projection_texture(occhiosx,occhio, "textures/fundo10.hr", FALSE, FALSE,1,1);

set_translate(corpo,0,1.050,1.16);
set_scale(corpo,0.2,0.2,0.2);
set_projection_texture(corpo,corpo_dino, "textures/doppioverde.hr", FALSE,FALSE,1,1);
set_scale(corpo,5,5,5);
set_translate(corpo,0,-1.050,-1.16);

set_translate(piano1,0,-0.05,-4.51);
set_scale(piano1,0.1,0.1,0.1);
set_projection_texture(piano1,base_piano, "textures/fundo11.hr", FALSE,FALSE,1,1);
set_scale(piano1,10,10,10);
set_translate(piano1,0,0.05,4.51);

set_translate(mani,0,-0.791,-1.551);
set_scale(mani,0.2,0.2,0.2);
set_projection_texture(mani,mani_dino, "textures/doppioverde.hr", FALSE,FALSE,1,1);
set_scale(mani,5,5,5);
set_translate(mani,0,0.791,1.551);	

/* Rotazioni */
set_z_rotate(corpo,80,1);
set_z_rotate(mani,80,1);
set_z_rotate(palla,80,1);
set_z_rotate(occhiodx,80,1);
set_z_rotate(occhiosx,80,1);

scena = create_list(corpo, "dinosauro");
scena = insert_in_list(scena, occhiodx);
scena = insert_in_list(scena, occhiosx);
scena = insert_in_list(scena, mani);
scena = insert_in_list(scena, piano);
scena = insert_in_list(scena, pareti);
scena = insert_in_list(scena, palla);
scena = insert_in_list(scena, canestro);
scena = insert_in_list(scena, pannello);
scena = insert_in_list(scena, tiro);
save_scene("scena.md","viso",scena);
return(0);

}


